Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osgIntrospection::CustomAttributeProvider Class Reference

This is the base class for custom attribute providers, that is objects that can be assigned a list of custom attributes. More...

Inheritance diagram for osgIntrospection::CustomAttributeProvider:

[legend]
List of all members.

## Public Member Functions
const CustomAttributeList & | getCustomAttributes () const
| Returns the const list of custom attributes.
CustomAttributeList & | getCustomAttributes ()
| Returns the list of custom attributes.
CustomAttributeProvider * | addAttribute (const CustomAttribute *attr)
| Adds a new attribute to the list.
bool | isDefined (const Type &type, bool inherit) const
| Returns whether at least one attribute of the given type is present in the attribute list.
template<typename T> bool | isDefined (bool inherit) const
| Returns whether at least one attribute of the given type is present in the attribute list.
const CustomAttribute * | getAttribute (const Type &type, bool inherit) const
| Searchs for an attribute of the given type and returns a pointer to it if found, a null pointer otherwise.
template<typename T> const T * | getAttribute (bool inherit) const
| Searchs for an attribute of the given type and returns a pointer to it if found, a null pointer otherwise.
## Protected Member Functions
virtual void | getInheritedProviders (CustomAttributeProviderList &providers) const=0
virtual | ~CustomAttributeProvider ()

## Detailed Description

This is the base class for custom attribute providers, that is objects that can be assigned a list of custom attributes.

Methods defined in this class provide the means for adding, retrieving and searching for attributes.

## Constructor & Destructor Documentation

virtual osgIntrospection::CustomAttributeProvider::~CustomAttributeProvider | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

CustomAttributeProvider* osgIntrospection::CustomAttributeProvider::addAttribute | ( | const CustomAttribute * | attr | ) | `[inline]`

| Adds a new attribute to the list.

template<typename T>
const T* osgIntrospection::CustomAttributeProvider::getAttribute | ( | bool | inherit | ) | const`[inline]`

| Searchs for an attribute of the given type and returns a pointer to it if found, a null pointer otherwise. If the inherit parameter is set to true, the search is forwarded to base types. [template version]

const CustomAttribute* osgIntrospection::CustomAttributeProvider::getAttribute | ( | const Type & | type,
|  | bool | inherit
| ) | const

| Searchs for an attribute of the given type and returns a pointer to it if found, a null pointer otherwise. If the inherit parameter is set to true, the search is forwarded to base types.

CustomAttributeList& osgIntrospection::CustomAttributeProvider::getCustomAttributes | ( |  | ) | `[inline]`

| Returns the list of custom attributes.

const CustomAttributeList& osgIntrospection::CustomAttributeProvider::getCustomAttributes | ( |  | ) | const`[inline]`

| Returns the const list of custom attributes.

virtual void osgIntrospection::CustomAttributeProvider::getInheritedProviders | ( | CustomAttributeProviderList & | providers | ) | const`[protected, pure virtual]`

| Implemented in osgIntrospection::ConstructorInfo, osgIntrospection::PropertyInfo, and osgIntrospection::Type.

template<typename T>
bool osgIntrospection::CustomAttributeProvider::isDefined | ( | bool | inherit | ) | const`[inline]`

| Returns whether at least one attribute of the given type is present in the attribute list. If the inherit parameter is set to true, the search is forwarded to base types. [template version]

bool osgIntrospection::CustomAttributeProvider::isDefined | ( | const Type & | type,
|  | bool | inherit
| ) | const

| Returns whether at least one attribute of the given type is present in the attribute list. If the inherit parameter is set to true, the search is forwarded to base types.

The documentation for this class was generated from the following file:

- CustomAttributeProvider